using System;
using System.Collections.Generic;
using System.Text;
using System.Collections.ObjectModel;

namespace Sample.Contracts
{
    [Serializable]
	public class KeyedByAccountNumberCollection
		:KeyedCollection<string, Account>
	{
		protected override string GetKeyForItem(Account item)
		{
			return item.AccountNumber;
		}

		//HACK: Apparently XmlSerializer calls the object IList.this[int index] indexer, rather than the type-specific indexer
		//so this workaround is required in order to serialize a KeyedCollection 
		public new Account this[int index] 
		{
			get { return ((IList<Account>)this)[index]; }
		}
	}
}
