using System;
using System.Collections.Generic;
using System.Text;
using System.Collections.ObjectModel;
using System.Globalization;

namespace Sample.Contracts
{
	[Serializable]
	public class Customer
		:ICustomer
	{

		#region Fields
		private int _customerId;
		private string _customerLogin;
		private string _firstName;
		private string _lastName;
		private Genre _genre;
		private DateTime _entryDate;
		private KeyedByAccountNumberCollection _accounts;
		#endregion

		#region Ctors
		public Customer()
		{}
		public Customer(string firstName, string lastName, Genre genre)
		{
			_firstName = firstName;
			_lastName = lastName;
			_genre = genre;
		}
		#endregion

		#region Props
		#region ICustomer Members

		public int CustomerId
		{
			get
			{
				return _customerId;
			}
			set
			{
				_customerId = value;
			}
		}

		public KeyedByAccountNumberCollection Accounts
		{
			get 
			{
				if (_accounts == null)
				{
					_accounts = new KeyedByAccountNumberCollection();
				}
				return _accounts; 
			}
		}
		public DateTime EntryDate
		{
			get { return _entryDate; }
			set { _entryDate = value; }
		}

		public string CustomerLogin
		{
			get
			{
				return _customerLogin;
			}
			set
			{
				_customerLogin = value;
			}
		}
		#endregion

		#region IPerson Members

		public string FirstName
		{
			get
			{
				return _firstName; ;
			}
			set
			{
				_firstName = value;
			}
		}
		public string LastName
		{
			get
			{
				return _lastName;
			}
			set
			{
				_lastName = value;
			}
		}

		public Genre Genre
		{
			get { return _genre; }
			set { _genre = value; }
		}
		#endregion

		#endregion

		#region Methods
		public override string ToString()
		{
			StringBuilder __stringBuilder = new StringBuilder();
			__stringBuilder.AppendLine("-=~ Customer Info ~=-");
			__stringBuilder.AppendLine(String.Format(CultureInfo.CurrentUICulture, "CustomerId: {0}", this.CustomerId));
            __stringBuilder.AppendLine(String.Format(CultureInfo.CurrentUICulture, "CustomerLogin: {0}", this.CustomerLogin));
            __stringBuilder.AppendLine(String.Format(CultureInfo.CurrentUICulture, "EntryDate: {0}", this.EntryDate.ToLongDateString()));
			__stringBuilder.AppendLine("-=~ Personal Info ~=-");
            __stringBuilder.AppendLine(String.Format(CultureInfo.CurrentUICulture, "FirstName: {0}", this.FirstName));
            __stringBuilder.AppendLine(String.Format(CultureInfo.CurrentUICulture, "LastName: {0}", this.LastName));
            __stringBuilder.AppendLine(String.Format(CultureInfo.CurrentUICulture, "Genre: {0}", this.Genre));
			__stringBuilder.AppendLine("\t-=~ Accounts Info ~=-");
			foreach (Account  account in this.Accounts)
			{
                __stringBuilder.AppendLine(String.Format(CultureInfo.CurrentUICulture, "\tAccount Name: {0}", account.AccountName));
                __stringBuilder.AppendLine(String.Format(CultureInfo.CurrentUICulture, "\tAccount Number: {0}", account.AccountNumber));
                __stringBuilder.AppendLine(String.Format(CultureInfo.CurrentUICulture, "\tBalance: {0}$", account.AccountBalance));
				__stringBuilder.AppendLine("\t-----------------------");
			}

			return __stringBuilder.ToString();
		}
		#endregion
	}
}
