using System;
using System.Collections.Generic;
using System.Text;
using thinktecture.ProxyModel;
using Sample.Contracts;
using thinktecture.ProxyModel.Web.Services;
using System.Diagnostics;

namespace WSClient
{
	class Program
	{
		static void Main(string[] args)
		{


			Program.DoIt();
			Console.WriteLine("Press [Enter] to exit");
			Console.ReadLine();
		}

		static void DoIt()
		{
			Stopwatch __stopwatch = new Stopwatch();

			Uri __wsHumanResourceUri = new Uri("http://localhost:1141/WebService/AccountManager.asmx?WSDL");
			__stopwatch.Start();
			ProxyFactory<IAccountManager> __proxyFactory = new ProxyFactory<IAccountManager>(__wsHumanResourceUri);
			IAccountManager __proxy = __proxyFactory.CreateProxy();

			__stopwatch.Stop();

			NetFxFactory.Utils.ConsoleWriter.WriteLineError(String.Format("Proxy creation took {0}ms", __stopwatch.ElapsedMilliseconds));
			NetFxFactory.Utils.ConsoleWriter.WriteLineInfo("Proxy created");
			NetFxFactory.Utils.ConsoleWriter.WriteLineInfo("Retreiving customer details");

			ICustomer __customer = __proxy.GetCustomerDetails("PTarker");
			NetFxFactory.Utils.ConsoleWriter.WriteLineDefault(__customer.ToString());
			NetFxFactory.Utils.ConsoleWriter.WriteLineInfo(String.Format("Credit {0} {1}'s account #:{2} with {3}$", __customer.FirstName, __customer.LastName, __customer.Accounts[0].AccountNumber, 121.17));

			__proxy.CreditAccount(__customer.CustomerLogin, __customer.Accounts[0].AccountNumber, 121.17);

			double __accountBalance = __proxy.GetAccountBalance(__customer.CustomerLogin, __customer.Accounts[0].AccountNumber);
			NetFxFactory.Utils.ConsoleWriter.WriteLineWarning(String.Format("Initial account balance: {0}$ \nPost credit operation account balance: {1}$", __customer.Accounts[0].AccountBalance, __accountBalance));
		}
	}
}

