using System;
using System.Collections.Generic;
using System.Text;
using Sample.Contracts;
using System.Configuration;
using System.Runtime.Remoting;
using thinktecture.ProxyModel;
using System.Diagnostics;
using System.Globalization;

namespace RemotingClient
{
    class Program
    {
        static void Main()
        {
            Program.DoIt();
            Console.WriteLine("Enter to the client process.");

            Console.WriteLine("Press [Enter] to do these operations again.");
            Console.ReadLine();

            Program.DoIt();
            Console.WriteLine("Press [Enter] to exit");
            Console.ReadLine();
            
            
        }

        static void DoIt()
        {
            Stopwatch __stopwatch = new Stopwatch();

            ISecuredCredentials __pTarkerSC = new SecuredCredentials("PTarker");

            __stopwatch.Start();
            ProxyFactory<IAccountManager> __proxyFactoryAccountManager = new ProxyFactory<IAccountManager>();
            IAccountManager __accountManager = __proxyFactoryAccountManager.CreateProxy();
            __stopwatch.Stop();

            NetFxFactory.Utils.ConsoleWriter.WriteLineError(String.Format(CultureInfo.CurrentUICulture, "Proxy creation took {0}ms", __stopwatch.ElapsedMilliseconds));
            NetFxFactory.Utils.ConsoleWriter.WriteLineInfo("Proxy created");
            NetFxFactory.Utils.ConsoleWriter.WriteLineInfo("Retreiving customer details");

            ICustomer __pTarker = __accountManager.GetCustomerDetails(__pTarkerSC);

            NetFxFactory.Utils.ConsoleWriter.WriteLineDefault(__pTarker.ToString());
            NetFxFactory.Utils.ConsoleWriter.WriteLineInfo(String.Format(CultureInfo.CurrentUICulture,"Credit {0} {1}'s account #:{2} with {3}$", __pTarker.FirstName, __pTarker.LastName, __pTarker.Accounts[0].AccountNumber, 121.17));

            __accountManager.CreditAccount(new SecuredCredentials(__pTarker), __pTarker.Accounts[0].AccountNumber, 121.17);

            NetFxFactory.Utils.ConsoleWriter.WriteLineWarning(String.Format(CultureInfo.CurrentUICulture, "Initial account balance: {0}$ \nPost credit operation account balance: {1}$", __pTarker.Accounts[0].AccountBalance, __accountManager.GetAccountBalance(new SecuredCredentials(__pTarker), __pTarker.Accounts[0].AccountNumber)));
        }
    }
}
