using System;
using System.Collections.Generic;
using System.Text;
using Sample.Contracts;

namespace Sample.Contracts
{
    public class AccountManager
        :MarshalByRefObject, IAccountManager
    {
        #region Ctor
        public AccountManager()
        {
            CustomerRepository.LoadCustomers();
        }
        #endregion

        #region Methods
        #region IAccountManager Members
        public ICustomer GetCustomerDetails(ISecuredCredentials customerSecuredCredentials)
        {
            Customer __customer;
            if (CustomerRepository.Repository.TryGetValue(customerSecuredCredentials.GetCustomerLogin(false), out __customer))
            {
                return __customer;
            }
            else
            {
                throw new CustomerNotFoundException("There is no customer matching these credentials");
            }
        }
        public double GetAccountBalance(ISecuredCredentials customerSecuredCredentials, string accountNumber)
        {
            Customer __customer;

            if (CustomerRepository.Repository.TryGetValue(customerSecuredCredentials.GetCustomerLogin(false), out __customer))
            {
                if (__customer.Accounts.Contains(accountNumber))
                {
                    return __customer.Accounts[accountNumber].AccountBalance;
                }
            }
            throw new CustomerNotFoundException("customerLogin or account number does not exist");
        }
        public bool CreditAccount(ISecuredCredentials customerSecuredCredentials, string accountNumber, double amount)
        {
            bool __succeeded = false;
            Customer __customer;

            if (CustomerRepository.Repository.TryGetValue(customerSecuredCredentials.GetCustomerLogin(false), out __customer))
            {
                if (__customer.Accounts.Contains(accountNumber))
                {
                    __customer.Accounts[accountNumber].CreditAccount(amount);
                }
                __succeeded = true;
            }

            return __succeeded;
        }
        #endregion
        #endregion
    }
}
