using System;
using System.Collections.Generic;
using System.Text;
using System.Security;

namespace Sample.Contracts
{
    [Serializable]
    public sealed class SecuredCredentials
        :ISecuredCredentials
    {
        #region Fields
        string _customerLogin;
        #endregion

        #region Ctors
        public SecuredCredentials(ICustomer customer)
        {
            if (customer == null)
                throw new ArgumentNullException("customer");
            
            _customerLogin = customer.CustomerLogin;
        }
        public SecuredCredentials(string customerLogin)
        {
            _customerLogin = customerLogin;
        }
        #endregion

        #region Methods
        public string GetCustomerLogin(bool areYouAHacker)
        {
            if (areYouAHacker)
            {
                throw new SecurityException("A hacker is trying to get a customer login");
            }
            else 
            {
                return _customerLogin;
            }
        }
        #endregion
    }
}
