using System;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using Sample.Contracts;

namespace WebService
{

    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    public class AccountManager : System.Web.Services.WebService, IAccountManager
    {
        #region Ctor
        public AccountManager()
        {
            CustomerRepository.LoadCustomers();
        }

        #endregion
        #region Methods
        [WebMethod]
        public Customer GetCustomerDetails(string customerLogin)
        {
            Customer __customer;
            if (CustomerRepository.Repository.TryGetValue(customerLogin, out __customer))
            {
                return __customer;
            }
            else
            {
                throw new CustomerNotFoundException("There is no customer matching these credentials");
            }
        }
        [WebMethod]
        public bool CreditAccount(string customerLogin, string accountNumber, double amount)
        {
            bool __succeeded = false;
            Customer __customer;

            if (CustomerRepository.Repository.TryGetValue(customerLogin, out __customer))
            {
                if (__customer.Accounts.Contains(accountNumber))
                {
                    __customer.Accounts[accountNumber].CreditAccount(amount);
                }
                __succeeded = true;
            }

            return __succeeded;
        }
        [WebMethod]
        public double GetAccountBalance(string customerLogin, string accountNumber)
        {
            Customer __customer;

            if (CustomerRepository.Repository.TryGetValue(customerLogin, out __customer))
            {
                if (__customer.Accounts.Contains(accountNumber))
                {
                    return __customer.Accounts[accountNumber].AccountBalance;
                }
            }
            throw new Exception("customerLogin or account number does not exist");
        }
        #endregion

    }
}