using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;
using Sample.Contracts;

namespace WebService
{
    /// <summary>
    /// Summary description for CustomerRepository
    /// </summary>
    public sealed class CustomerRepository
    {
        #region Fields
        private static IDictionary<string, Customer> _repository = new Dictionary<string, Customer>();

        #endregion

        #region Ctors
        private CustomerRepository()
        { }
        #endregion

        #region Properties
        public static IDictionary<string, Customer> Repository
        {
            get { return _repository; }
        }
        #endregion

        #region Methods
        public static void LoadCustomers()
        {
            Customer __customer1 = new Customer("Pony", "Tarker", Genre.Male);
            __customer1.CustomerId = 1;
            __customer1.CustomerLogin = "PTarker";
            __customer1.EntryDate = new DateTime(2000, 4, 18);
            __customer1.Accounts.Add(new Account("123Z", "Deposit", 120.51));
            __customer1.Accounts.Add(new Account("456U", "Savings", 15448.72));

            Customer __customer2 = new Customer("Doris", "Biaw", Genre.Male);
            __customer2.CustomerId = 1;
            __customer2.CustomerLogin = "DBiaw";
            __customer2.EntryDate = new DateTime(2001, 6, 6);
            __customer2.Accounts.Add(new Account("789B", "Deposit", 147.44));
            __customer2.Accounts.Add(new Account("147V", "Savings", 7528.11));

            if (!_repository.ContainsKey(__customer1.CustomerLogin))
            {
                _repository.Add(__customer1.CustomerLogin, __customer1);
            }
            if (!_repository.ContainsKey(__customer2.CustomerLogin))
            {
                _repository.Add(__customer2.CustomerLogin, __customer2);
            }
        }
        #endregion

    }
}