using System;
using System.Collections.Generic;
using System.Text;
using Sample.Contracts;

namespace WSClient
{
  public interface IAsynchronousAccountManager : IAccountManager
  {
    IAsyncResult BeginCreditAccount(string customerLogin, string accountNumber, double amount, AsyncCallback callback, object asyncState);
    IAsyncResult BeginGetAccountBalance(string customerLogin, string accountNumber, AsyncCallback callback, object asyncState);
    IAsyncResult BeginGetCustomerDetails(string customerLogin, AsyncCallback callback, object asyncState);

    bool EndCreditAccount(IAsyncResult asyncResult);
    double EndGetAccountBalance(IAsyncResult asyncResult);
    Customer EndGetCustomerDetails(IAsyncResult asyncResult);
  }
}
