using System;
using System.Collections.Generic;
using System.Text;
using thinktecture.ProxyModel;
using Sample.Contracts;
using thinktecture.ProxyModel.Web.Services;
using System.Diagnostics;

namespace WSClient
{
	class Program
	{
		static void Main(string[] args)
		{
			Program.DoIt();
			Console.WriteLine("Press [Enter] to exit");
			Console.ReadLine();
		}

		static void DoIt()
		{
			Stopwatch __stopwatch = new Stopwatch();

			Uri __wsHumanResourceUri = new Uri("http://localhost:1150/WebService/AccountManager.asmx?WSDL");
			__stopwatch.Start();
			ProxyFactory<IAsynchronousAccountManager> __proxyFactory = new ProxyFactory<IAsynchronousAccountManager>(__wsHumanResourceUri);
			IAsynchronousAccountManager __proxy = __proxyFactory.CreateProxy();
			__stopwatch.Stop();

			NetFxFactory.Utils.ConsoleWriter.WriteLineError(String.Format("Proxy creation took {0}ms", __stopwatch.ElapsedMilliseconds));
			NetFxFactory.Utils.ConsoleWriter.WriteLineInfo("Proxy created");
			NetFxFactory.Utils.ConsoleWriter.WriteLineInfo("Retreiving customer details");

			//Instantiate an AsyncCallback delegate to use as a parameter in the BeginGetCustomerDetails method.
			AsyncCallback __getCustomerDetailsCallback = new AsyncCallback(GetCustomerDetailsCallback);
			IAsyncResult __getCustomerDetailsAsyncResult = __proxy.BeginGetCustomerDetails("PTarker", __getCustomerDetailsCallback, __proxy);

			NetFxFactory.Utils.ConsoleWriter.WriteLineDefault("Asynchronous call initiated.");
		}

		public static void GetCustomerDetailsCallback(IAsyncResult asyncResult)
		{
			// You passed in our instance of IAsynchronousAccountManager in the third
			// parameter to BeginGetCustomerDetails, which is accessible in the
			// AsyncState property.
			IAsynchronousAccountManager __proxy = (IAsynchronousAccountManager)asyncResult.AsyncState;

			// Get the completed results.
			Customer __customer = __proxy.EndGetCustomerDetails(asyncResult);

			NetFxFactory.Utils.ConsoleWriter.WriteLineDefault(__customer.ToString());
		}
	}
}

