using System;
using System.Collections.Generic;
using System.Text;

namespace Sample.Contracts
{
	[Serializable]
  public class Account
		: IAccount
	{

		#region Fields
		private string _accountNumber;
		private string _accountName;
		private double _accountBalance;
		#endregion

		#region Ctors
		public Account()
		{}
		public Account(string accountNumber, string accountName, double initialBalance)
		{
			_accountNumber = accountNumber;
			_accountName = accountName;
			_accountBalance = initialBalance;
		}
		#endregion

		#region Props
		#region IAccount Members

		public string AccountNumber
		{
			get
			{
				return _accountNumber;
			}
			set
			{
				_accountNumber = value;
			}
		}
		public string AccountName
		{
			get
			{
				return _accountName;
			}
			set
			{
				_accountName = value;
			}
		}
		public double AccountBalance
		{
			get { return _accountBalance; }
			set { _accountBalance = value; }
		}

		#endregion
		#endregion

		#region Methods
		public void CreditAccount(double amount)
		{
			_accountBalance += amount;
		}
		public void WithdrawCash(double amount)
		{
			_accountBalance -= amount;
		}
		#endregion
	}
}
