using System;
using System.Collections.Generic;
using System.Text;
using Sample.Contracts;

namespace WcfService
{
  public class AccountManager
    :IAccountManager
  {

    public Customer GetCustomerDetails(string customerLogin)
    {
      Customer __customer;
      if (CustomerRepository.Repository.TryGetValue(customerLogin, out __customer))
      {
        return __customer;
      }
      else
      {
        throw new CustomerNotFoundException("There is no customer matching these credentials");
      }
    }

    public double GetAccountBalance(string customerLogin, string accountNumber)
    {
      Customer __customer;

      if (CustomerRepository.Repository.TryGetValue(customerLogin, out __customer))
      {
        if (__customer.Accounts.Contains(accountNumber))
        {
          return __customer.Accounts[accountNumber].AccountBalance;
        }
      }
      throw new Exception("customerLogin or account number does not exist");
    }

    public bool CreditAccount(string customerLogin, string accountNumber, double amount)
    {
      bool __succeeded = false;
      Customer __customer;

      if (CustomerRepository.Repository.TryGetValue(customerLogin, out __customer))
      {
        if (__customer.Accounts.Contains(accountNumber))
        {
          __customer.Accounts[accountNumber].CreditAccount(amount);
        }
        __succeeded = true;
      }

      return __succeeded;
    }

  }
}
