using System;
using System.Collections.Generic;
using System.Text;
using thinktecture.ProxyModel;
using thinktecture.ProxyModel.Test;

namespace Client
{
  class Program
  {
    static void TestIt(ProxyFactory<IStockService> proxyFactory)
    {
      Console.ForegroundColor = ConsoleColor.Green;
      IStockService __proxy = proxyFactory.CreateProxy();

      // Call the service
      String[] symbols = { "FABRIKAM", "CONTOSO" };
      StockQuote[] quotes = __proxy.GetStockQuotes(symbols);

      // Success!
      Console.WriteLine("Remote Service called successfully. Simple view:");
      foreach (StockQuote quote in quotes)
      {
        Console.WriteLine("");
        Console.WriteLine("Symbol: " + quote.Symbol);
        Console.WriteLine("\tName:\t\t\t" + quote.Name);
        Console.WriteLine("\tLast Price:\t\t" + quote.Last);
        Console.WriteLine("\tPrevious Change:\t" + quote.PreviousChange + "%");
      }

      Console.ResetColor();
    }
    static void Main(string[] args)
    {
      Console.WriteLine("Instantiate ProxyFactory<IStockService>()");
      Console.WriteLine("Uses the first endpoint element defined for this contract in the configuration file.");
      //CALL TESTIT() WITH CORRECT PARAMETER(S)

      Console.WriteLine();
      Console.WriteLine("Press [Enter] to continue");
      Console.ReadLine();

      Console.WriteLine("Instantiate a new ProxyFactory<IStockService>(\"RemotingStockServiceOverWS\")");
      Console.WriteLine("Uses the endpoint element named \"RemotingStockServiceOverWS\" defined for this contract in the configuration file.");
      //CALL TESTIT() WITH CORRECT PARAMETER(S)

      Console.WriteLine();
      Console.WriteLine("Press [Enter] to continue");
      Console.ReadLine();

      Console.WriteLine("Instantiate a new ProxyFactory<IStockService>(\"RemotingStockServiceOverRemoting\")");
      Console.WriteLine("Uses the endpoint element named \"RemotingStockServiceOverRemoting\" defined for this contract in the configuration file.");
      //CALL TESTIT() WITH CORRECT PARAMETER(S)

      Console.WriteLine();
      Console.WriteLine("Press [Enter] to continue");
      Console.ReadLine();

      Console.WriteLine("Instantiate a new ProxyFactory<IStockService>() with these parameters");
      Console.WriteLine("CommunicationTechnology.WebServices and new Uri(\"http://localhost:51640/WebService/StockService.asmx?WSDL\")");
      //CALL TESTIT() WITH CORRECT PARAMETER(S)

      Console.WriteLine("Press any key to exit!");
      Console.ReadLine();
    }
  }
}
