using System;
using System.Collections.Generic;
using System.Text;

namespace thinktecture.ProxyModel.Test
{
  public sealed class StockService : MarshalByRefObject, IStockService
  {
    #region ctors

    public StockService()
    {

    }

    #endregion
    #region methods

    public StockQuote[] GetStockQuotes(string[] symbols)
    {
      //
      // Random stock quote implementation
      //
      List<StockQuote> quotes = new List<StockQuote>();

      Random rnd = new Random();

      foreach (String symbol in symbols)
      {
        StockQuote quote = new StockQuote();
        double price = rnd.NextDouble() * 100;
        quote.Symbol = symbol;
        quote.Date = DateTime.Now;
        quote.Last = price;
        quote.Change = rnd.NextDouble() * 10;
        quote.High = price + 10;
        quote.Low = (price - 10 > 0) ? price - 10 : 0;
        quotes.Add(quote);
      }
      return quotes.ToArray();
    }

    #endregion
  }
}
