using System;
using System.Collections.Generic;
using System.Text;
using System.Collections.ObjectModel;

namespace PurpleMediaCenter
{
  public sealed class PersonKeyedCollectionByName : KeyedCollection<string, Person>
  {
    #region ctors

    public PersonKeyedCollectionByName()
    {
    }
    public PersonKeyedCollectionByName(IEnumerable<Person> persons)
    {
      foreach (Person person in persons)
      {
        this.Add(person);
      }
    }

    #endregion
    #region methods

    protected override string GetKeyForItem(Person item)
    {
      return PersonKeyedCollectionByName.GetKey(item);
    }
    public Person[] ToArray()
    {
      Person[] __persons = new Person[this.Items.Count];
      this.CopyTo(__persons, 0);
      return __persons;
    }
    public static string GetKey(Person person)
    {
      return string.Format("{0}|{1}", person.FirstName, person.LastName).ToLower();
    }

    #endregion
  }
}
