using System;
using System.Collections.Generic;
using System.Text;
using System.Web.Services;

namespace PurpleMediaCenter.FinderServices.Asmx
{
  [WebService(Namespace = "urn:PurpleMediaCenter.FinderServices")]
  [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
  public sealed class MovieFinder : IMovieFinder
  {
    #region methods

    [WebMethod]
    public Movie[] GetMoviesByActor(Person actor)
    {
      return GlobalRepository.GetMoviesByActor(actor);
    }
    [WebMethod]
    public Movie[] GetMoviesByDirector(Person director)
    {
      return GlobalRepository.GetMoviesByDirector(director);
    }
    [WebMethod]
    public Movie[] GetMoviesByTitle(string title)
    {
      return GlobalRepository.GetMoviesByTitle(title);
    }
    [WebMethod]
    public Movie[] GetMoviesByDirectorFor(Person director, int[] years)
    {
      return GlobalRepository.GetMoviesByDirectorFor(director, years);
    }
    [WebMethod]
    public Person[] WereDirectedBy(Person director)
    {
      return GlobalRepository.WereDirectedBy(director);
    }

    #endregion
  }
}
