using System;
using System.Collections.Generic;
using System.Text;
using System.Web.Services;

namespace PurpleMediaCenter.FinderServices.Asmx
{
  [WebService(Namespace = "urn:PurpleMediaCenter.FinderServices")]
  [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
  public sealed class MovieLibrary : IMovieManager, IMovieFinder
  {
    #region methods

    [WebMethod]
    public Movie[] GetMoviesByActor(Person actor)
    {
      return GlobalRepository.GetMoviesByActor(actor);
    }
    [WebMethod]
    public Movie[] GetMoviesByDirector(Person director)
    {
      return GlobalRepository.GetMoviesByDirector(director);
    }
    [WebMethod]
    public Movie[] GetMoviesByTitle(string title)
    {
      return GlobalRepository.GetMoviesByTitle(title);
    }
    [WebMethod]
    public Movie[] GetMoviesByDirectorFor(Person director, int[] years)
    {
      return GlobalRepository.GetMoviesByDirectorFor(director, years);
    }
    [WebMethod]
    public Person[] WereDirectedBy(Person director)
    {
      return GlobalRepository.WereDirectedBy(director);
    }
    [WebMethod]
    public void AddMovie(Movie movie)
    {
      GlobalRepository.AddMovie(movie);
    }
    [WebMethod]
    public void AddActor(Person actor)
    {
      GlobalRepository.AddActor(actor);
    }
    [WebMethod]
    public void AddActors(Person[] actors)
    {
      GlobalRepository.AddActors(actors);
    }
    [WebMethod]
    public void AddDirector(Person director)
    {
      GlobalRepository.AddDirector(director);
    }
    [WebMethod]
    public void AddDirectors(Person[] directors)
    {
      GlobalRepository.AddDirectors(directors);
    }

    #endregion
  }
}
