using System;
using System.Collections.Generic;
using System.Text;
using System.Web.Services;

namespace PurpleMediaCenter.FinderServices.Remoting
{
  public sealed class MovieFinder : MarshalByRefObject, IMovieFinder
  {
    #region methods

    public Movie[] GetMoviesByActor(Person actor)
    {
      return GlobalRepository.GetMoviesByActor(actor);
    }
    public Movie[] GetMoviesByDirector(Person director)
    {
      return GlobalRepository.GetMoviesByDirector(director);
    }
    public Movie[] GetMoviesByTitle(string title)
    {
      return GlobalRepository.GetMoviesByTitle(title);
    }
    public Movie[] GetMoviesByDirectorFor(Person director, int[] years)
    {
      return GlobalRepository.GetMoviesByDirectorFor(director, years);
    }
    public Person[] WereDirectedBy(Person director)
    {
      return GlobalRepository.WereDirectedBy(director);
    }

    #endregion
  }
}
