#region (c) 2002-2006 by thinktecture
// **********************************************************************
//
//  2002-2006 by thinktecture, Ingo Rammer and Christian Weyer. All rights reserved.
//
// This copy of thinktecture is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// Christian Weyer (christian.weyer@thinktecture.com)
//
// **********************************************************************
#endregion
#region (c) 2006 by netfxfactory.org
// **********************************************************************
//
//  2006 by netfxfactory.org. All rights reserved.
//
// This copy is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// pascal.recchia@netfxfactory.org
// anthony.guerot@netfxfactory.org
// **********************************************************************
#endregion

using System;
using System.Collections.Generic;
using System.Text;

namespace thinktecture.ProxyModel
{
  internal abstract class BaseCommunicationPlatform : DependencyObject
  {
    #region props

    public abstract CommunicationTechnology CommunicationTechnology { get; }

    #endregion
    #region methods

    public abstract bool IsDefined(Type contractType, Uri uri);
    public abstract object GetProxy(Type contractType, Uri uri);
    public virtual bool IsDefined(Type contractType)
    {
      return this.IsDefined(contractType, null);
    }
    public virtual object GetProxy(Type contractType)
    {
      return this.GetProxy(contractType, null);
    }

    #endregion
  }
}
