using System;
using System.Collections.Generic;
using System.Text;

namespace thinktecture.ProxyModel.Configuration
{
  public static class ConfigurationSettings
  {
    #region methods

    private static string GetSectionPath(string sectionName)
    {
      return string.Format("{0}/{1}", ConfigurationStrings.ProxyModelSectionGroupName, sectionName);
    }
    internal static System.Configuration.Configuration GetConfiguration()
    {
      System.Web.HttpContext __httpContextCurrent = System.Web.HttpContext.Current;
      if (__httpContextCurrent == null)
      {
        return System.Configuration.ConfigurationManager.OpenExeConfiguration(System.Configuration.ConfigurationUserLevel.None);
      }
      else
      {
        return System.Web.Configuration.WebConfigurationManager.OpenWebConfiguration(__httpContextCurrent.Request.ApplicationPath);
      }
    }
    public static ProxyModelSectionGroup GetProxyModelSectionGroup()
    {
      return (ProxyModelSectionGroup)ConfigurationSettings.GetConfiguration().GetSectionGroup(ConfigurationStrings.ProxyModelSectionGroupName);
    }
    public static ClientSection GetClientSection()
    {
      return (ClientSection)ConfigurationSettings.GetConfiguration().GetSection(ConfigurationSettings.GetSectionPath(ConfigurationStrings.ClientSectionName));
    }
    public static EndpointElement GetEndpointElement(Type contractType)
    {
      ClientSection __clientSection = ConfigurationSettings.GetClientSection();
      if (__clientSection == null)
      {
        return null;
      }
      return __clientSection.Endpoints.GetEndpointElement(contractType);
    }
    public static EndpointElement GetEndpointElement(Type contractType, string endpointName)
    {
      ClientSection __clientSection = ConfigurationSettings.GetClientSection();
      return __clientSection.Endpoints.GetEndpointElement(contractType, endpointName);
    }

    #endregion
  }
}
