#region (c) 2002-2006 by thinktecture
// **********************************************************************
//
//  2002-2006 by thinktecture, Ingo Rammer and Christian Weyer. All rights reserved.
//
// This copy of thinktecture is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// Christian Weyer (christian.weyer@thinktecture.com)
//
// **********************************************************************
#endregion
#region (c) 2006 by netfxfactory.org
// **********************************************************************
//
//  2006 by netfxfactory.org. All rights reserved.
//
// This copy is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// pascal.recchia@netfxfactory.org
// anthony.guerot@netfxfactory.org
// **********************************************************************
#endregion

using System;
using System.Text;
using System.Configuration;
using System.Collections.Generic;

namespace thinktecture.ProxyModel.Configuration
{
  [ConfigurationCollection(typeof(EndpointElement), AddItemName = "endpoint")]
  public sealed class EndpointElementCollection : ConfigurationElementCollection
  {
    #region ctors

    public EndpointElementCollection()
    {
    }

    #endregion
    #region methods

    protected override ConfigurationElement CreateNewElement()
    {
      return new EndpointElement();
    }
    protected override object GetElementKey(ConfigurationElement element)
    {
      EndpointElement __endpointElement = (EndpointElement)element;
      return __endpointElement.Key;
    }
    public EndpointElement GetEndpointElement(Type contractType)
    {
      return (EndpointElement)base.BaseGet(EndpointElement.GetKey(contractType));
    }
    public EndpointElement GetEndpointElement(Type contractType, string endpointName)
    {
      return (EndpointElement)base.BaseGet(EndpointElement.GetKey(contractType, endpointName));
    }

    #endregion
  }
}
