#region (c) 2002-2006 by thinktecture
// **********************************************************************
//
//  2002-2006 by thinktecture, Ingo Rammer and Christian Weyer. All rights reserved.
//
// This copy of thinktecture is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// Christian Weyer (christian.weyer@thinktecture.com)
//
// **********************************************************************
#endregion
#region (c) 2006 by netfxfactory.org
// **********************************************************************
//
//  2006 by netfxfactory.org. All rights reserved.
//
// This copy is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// pascal.recchia@netfxfactory.org
// anthony.guerot@netfxfactory.org
// **********************************************************************
#endregion

using System;
using System.Collections.Generic;
using System.Text;

namespace thinktecture.ProxyModel
{
  public sealed class DependencyProperty
  {
    #region fields

    private string _name;
    private Type _propertyType;
    private Type _ownerType;
    private object _defaultValue;

    #endregion
    #region ctors

    private DependencyProperty(string name, Type propertyType, Type ownerType, object defaultValue)
    {
      if ((defaultValue !=  null) && (defaultValue.GetType() != propertyType))
      {
        // TODO : Localize this message
        throw new InvalidCastException(string.Format("The type of the default value:{0} is not the expected type:{1}.", defaultValue.GetType(), propertyType));
      }
      _name = name;
      _propertyType = propertyType;
      _ownerType = ownerType;
      _defaultValue = defaultValue;
    }

    #endregion
    #region props

    internal Type OwnerType
    {
      get { return _ownerType; }
      set { _ownerType = value; }
    }
    internal Type PropertyType
    {
      get { return _propertyType; }
      set { _propertyType = value; }
    }
    internal string Name
    {
      get { return _name; }
      set { _name = value; }
    }
    internal object DefaultValue
    {
      get { return _defaultValue; }
      set { _defaultValue = value; }
    }

    #endregion
    #region methods

    internal static DependencyProperty Register(string name, Type propertyType, Type ownerType)
    {
      DependencyProperty __dependencyProperty = new DependencyProperty(name, propertyType, ownerType, null);
      //_dependencyProperties.Add(__dependencyProperty);
      return __dependencyProperty;
    }
    internal static DependencyProperty Register(string name, Type propertyType, Type ownerType, object defaultValue)
    {
      DependencyProperty __dependencyProperty = new DependencyProperty(name, propertyType, ownerType, defaultValue);
      //_dependencyProperties.Add(__dependencyProperty);
      return __dependencyProperty;
    }

    #endregion
  }
}
