using System;
using System.Collections.Generic;
using System.Text;

namespace Thinktecture.ProxyModel
{
  /// <summary>
  /// Defines capabilities for communication platforms in order to be used by the <see cref="ProxyModel.ProxyFactory{TContract}"/> class. 
  /// </summary>
  internal interface ICommunicationPlatform
  {
    /// <summary>
    /// Gets the communication technology associated with this communication platform.
    /// </summary>
    /// <value>The communication technology.</value>
    CommunicationTechnology CommunicationTechnology { get;}
    ///// <summary>
    ///// Tries to get the URI associated with the specified service contract type.
    ///// </summary>
    ///// <param name="contractType">Type of the service contract.</param>
    ///// <param name="contractType">Type of the service contract.</param>
    ///// <returns>True if the uri has been found form this communication platform configuration, othrewise false.</returns>
    bool IsDefined(Type contractType);
    bool IsDefined(Type contractType, Uri uri);
    object GetProxy(Type contractType, Uri uri);
    object GetProxy(Type contractType);
  }
}
