#region (c) 2002-2006 by thinktecture
// **********************************************************************
//
//  2002-2006 by thinktecture, Ingo Rammer and Christian Weyer. All rights reserved.
//
// This copy of thinktecture is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// Christian Weyer (christian.weyer@thinktecture.com)
//
// **********************************************************************
#endregion
#region (c) 2006 by netfxfactory.org
// **********************************************************************
//
//  2006 by netfxfactory.org. All rights reserved.
//
// This copy is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// pascal.recchia@netfxfactory.org
// anthony.guerot@netfxfactory.org
// **********************************************************************
#endregion

using System;
using System.Collections.Generic;
using System.Text;
using System.Net;

namespace thinktecture.ProxyModel.Web.Services
{
  internal class AdvancedWebClient : WebClient
  {
    #region fields

    private bool _isFromCache;

    #endregion
    #region ctors

    public AdvancedWebClient():base()
    {

    }

    #endregion
    #region props

    public bool IsFromCache
    {
      get { return _isFromCache; }
    }

    #endregion
    #region methods

    protected override WebResponse GetWebResponse(WebRequest request)
    {
      WebResponse __webResponse = base.GetWebResponse(request);
      _isFromCache = __webResponse.IsFromCache;
      return __webResponse;
    }
    protected override WebResponse GetWebResponse(WebRequest request, IAsyncResult result)
    {
      WebResponse __webResponse = base.GetWebResponse(request, result);
      _isFromCache = __webResponse.IsFromCache;
      return __webResponse;
    }

    #endregion
  }
}
