#region (c) 2002-2006 by thinktecture
// **********************************************************************
//
//  2002-2006 by thinktecture, Ingo Rammer and Christian Weyer. All rights reserved.
//
// This copy of thinktecture is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// Christian Weyer (christian.weyer@thinktecture.com)
//
// **********************************************************************
#endregion
#region (c) 2006 by netfxfactory.org
// **********************************************************************
//
//  2006 by netfxfactory.org. All rights reserved.
//
// This copy is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// pascal.recchia@netfxfactory.org
// anthony.guerot@netfxfactory.org
// **********************************************************************
#endregion

using System;
using System.Collections.Generic;
using System.Text;

namespace thinktecture.ProxyModel.Web.Services
{
  /// <summary>
  /// Specifies caching behavior for proxy assembly generated from a specified wsdl.
  /// </summary>
  public enum CachePolicy
  {
    /// <summary>
    /// Clears the assembly cached locally only if the wsdl do not match the one used to generate this assembly.
    /// </summary>
    CheckWsdlForInvalidation = 0,
    /// <summary>
    /// Satisfies a request using the locally cached proxy assembly; does not send a request for an item that is not in the cache. When this cache policy level is specified, a CachedAssemblyNotFoundException exception is thrown if the proxy assembly is not in the client cache. 
    /// </summary>
    LocalCacheOnly = 1,
    /// <summary>
    /// Satisfies a request using the locally cached proxy assembly but sends a request for an item that is not in the cache. 
    /// </summary>
    LocalCacheIfAvailable = 2,
    /// <summary>
    /// Clears all the assemblies cached locally before satisfying a request.
    /// </summary>
    ClearAllCachedAssemblies = 3,
    /// <summary>
    /// Clears only the assembly cached locally that matches the request's wsdl.
    /// </summary>
    ClearMatchingCachedAssembly = 4,
  }
}
