#region (c) 2002-2006 by thinktecture
// **********************************************************************
//
//  2002-2006 by thinktecture, Ingo Rammer and Christian Weyer. All rights reserved.
//
// This copy of thinktecture is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// Christian Weyer (christian.weyer@thinktecture.com)
//
// **********************************************************************
#endregion
#region (c) 2006 by netfxfactory.org
// **********************************************************************
//
//  2006 by netfxfactory.org. All rights reserved.
//
// This copy is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// pascal.recchia@netfxfactory.org
// anthony.guerot@netfxfactory.org
// **********************************************************************
#endregion

using System;
using System.Collections.Generic;
using System.Text;
using System.CodeDom;
using System.Web.Services;

namespace thinktecture.ProxyModel.Web.Services
{
  internal static class CodeDomHelper
  {
    internal static WebServiceAttribute GetWebServiceAttribute(CodeTypeDeclaration codeTypeDeclaration)
    {
      // Instance a new WebServiceAttribute instance from information retrieved from the WebServiceBindingAttribute CodeAttributeDeclaration of the specified CodeTypeDeclaration instance.
      WebServiceAttribute __webServiceAttribute = null;
      foreach (CodeAttributeDeclaration codeAttributeDeclaration in codeTypeDeclaration.CustomAttributes)
      {
        if (codeAttributeDeclaration.AttributeType.BaseType == typeof(WebServiceBindingAttribute).FullName)
        {
          __webServiceAttribute = new WebServiceAttribute();
          foreach (CodeAttributeArgument codeAttributeArgument in codeAttributeDeclaration.Arguments)
          {
            if (codeAttributeArgument.Name == "Name")
            {
              __webServiceAttribute.Name = ((CodePrimitiveExpression)codeAttributeArgument.Value).Value.ToString();
            }
            if (codeAttributeArgument.Name == "Namespace")
            {
              __webServiceAttribute.Namespace = ((CodePrimitiveExpression)codeAttributeArgument.Value).Value.ToString();
            }
          }
          return __webServiceAttribute;
        }
      }
      return null;
    }
    internal static WebServiceAttribute GetWebServiceAttribute(Type type)
    {
      object[] __attributes = type.GetCustomAttributes(typeof(WebServiceAttribute), true);
      if (__attributes.Length != 1)
      {
        return null;
      }
      WebServiceAttribute __webServiceAttribute = (WebServiceAttribute)__attributes[0];
      // TODO : type.Name ???
      __webServiceAttribute.Name = (string.IsNullOrEmpty(__webServiceAttribute.Name) ? type.Name : __webServiceAttribute.Name);
      return __webServiceAttribute;
    }
    internal static int Compare(WebServiceAttribute x, WebServiceAttribute y)
    {
      int __nameCompareTo = x.Name.CompareTo(y.Name);
      int __namespaceCompareTo = x.Namespace.CompareTo(y.Namespace);

      if (__nameCompareTo != 0)
      {
        return __nameCompareTo;
      }
      if (__namespaceCompareTo != 0)
      {
        return __namespaceCompareTo;
      }
      return 0;
    }
  }
}
