#region (c) 2002-2006 by thinktecture
// **********************************************************************
//
//  2002-2006 by thinktecture, Ingo Rammer and Christian Weyer. All rights reserved.
//
// This copy of thinktecture is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// Christian Weyer (christian.weyer@thinktecture.com)
//
// **********************************************************************
#endregion
#region (c) 2006 by netfxfactory.org
// **********************************************************************
//
//  2006 by netfxfactory.org. All rights reserved.
//
// This copy is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// pascal.recchia@netfxfactory.org
// anthony.guerot@netfxfactory.org
// **********************************************************************
#endregion

using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;
using System.CodeDom.Compiler;

namespace thinktecture.ProxyModel.Web.Services
{
  [Serializable]
  public class DynamicCompilationException : Exception
  {
    #region ctors

    /// <summary>
    /// Creates a new <see cref="DynamicCompilationException"/> instance.
    /// </summary>
    /// <param name="compilerResults">The results of compilation which has thrown at least an error.</param>
    public DynamicCompilationException(CompilerResults compilerResults)
      : base(DynamicCompilationException.GetExceptionMessage(compilerResults))
    {
    }

    #endregion
    #region methods

    /// <summary>
    /// Get the exception message associated with a specified compilation results.
    /// </summary>
    /// <param name="compilerResults"></param>
    /// <returns></returns>
    public static string GetExceptionMessage(CompilerResults compilerResults)
    {
      if (compilerResults.Errors.Count == 0)
      {
        throw new ArgumentException("There are no error messages.", "compilerResults");
      }
      StringBuilder __message = new StringBuilder("Building dynamic assembly failed: ");
      __message.AppendFormat("{0} errors", compilerResults.Errors.Count);
      foreach (CompilerError compilerError in compilerResults.Errors)
      {
        __message.AppendLine(compilerError.ToString());
      }
      return __message.ToString();
    }

    #endregion
  }
}
