#region (c) 2002-2006 by thinktecture
// **********************************************************************
//
//  2002-2006 by thinktecture, Ingo Rammer and Christian Weyer. All rights reserved.
//
// This copy of thinktecture is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// Christian Weyer (christian.weyer@thinktecture.com)
//
// **********************************************************************
#endregion
#region (c) 2006 by netfxfactory.org
// **********************************************************************
//
//  2006 by netfxfactory.org. All rights reserved.
//
// This copy is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// pascal.recchia@netfxfactory.org
// anthony.guerot@netfxfactory.org
// **********************************************************************
#endregion

using System;
using System.Collections.Generic;
using System.Text;
using System.Security.Cryptography.X509Certificates;
using System.Net;

namespace thinktecture.ProxyModel.Web.Services
{
  /// <summary>
  /// Defines the contract that ASP.NET XML Web service client proxies, that use the HTTP transport protocol, implements.
  /// </summary>
  /// <seealso cref="HttpWebClientProtocol"/>
  public interface IHttpWebClientProtocol : IWebClientProtocol
  {
    #region props

    /// <summary>
    /// Gets or sets whether the client automatically follows server redirects.
    /// </summary>
    bool AllowAutoRedirect { get; set; }
    /// <summary>
    /// Gets the collection of client certificates.
    /// </summary>
    X509CertificateCollection ClientCertificates { get; }
    /// <summary>
    /// Gets or sets the collection of cookies.
    /// </summary>
    CookieContainer CookieContainer { get; set; }
    /// <summary>
    /// Gets or sets a Boolean that indicates whether decompression is enabled for this <see cref="HttpWebClientProtocol"/>. 
    /// </summary>
    bool EnableDecompression { get; set; }
    /// <summary>
    /// Gets or sets proxy information for making an XML Web service request through a firewall.
    /// </summary>
    IWebProxy Proxy { get; set; }
    /// <summary>
    /// Gets or sets a value that indicates whether connection sharing is enabled when the client uses NTLM authentication to connect to the Web server that hosts the XML Web service.
    /// </summary>
    bool UnsafeAuthenticatedConnectionSharing { get; set; }
    /// <summary>
    /// Gets or sets the value for the user agent header that is sent with each request.
    /// </summary>
    string UserAgent { get; set; }

    #endregion
  }
}
