#region (c) 2002-2006 by thinktecture
// **********************************************************************
//
//  2002-2006 by thinktecture, Ingo Rammer and Christian Weyer. All rights reserved.
//
// This copy of thinktecture is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// Christian Weyer (christian.weyer@thinktecture.com)
//
// **********************************************************************
#endregion
#region (c) 2006 by netfxfactory.org
// **********************************************************************
//
//  2006 by netfxfactory.org. All rights reserved.
//
// This copy is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// pascal.recchia@netfxfactory.org
// anthony.guerot@netfxfactory.org
// **********************************************************************
#endregion

using System;
using System.Collections.Generic;
using System.Text;
using System.Web.Services.Protocols;

namespace thinktecture.ProxyModel.Web.Services
{
  /// <summary>
  /// Defines the contract that ASP.NET XML Web service client proxies, using SOAP, implements.
  /// </summary>
  public interface ISoapHttpClientProtocol : IHttpWebClientProtocol
  {
    #region props

    /// <summary>
    /// Gets or sets the version of the SOAP protocol used to make the SOAP request to the XML Web service.
    /// </summary>
    SoapProtocolVersion SoapVersion { get; set; }

    #endregion
    #region methods

    /// <summary>
    /// Dynamically binds to an XML Web service described in the discovery document at Url.
    /// </summary>
    void Discover();

    #endregion
  }
}
