#region (c) 2002-2006 by thinktecture
// **********************************************************************
//
//  2002-2006 by thinktecture, Ingo Rammer and Christian Weyer. All rights reserved.
//
// This copy of thinktecture is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// Christian Weyer (christian.weyer@thinktecture.com)
//
// **********************************************************************
#endregion
#region (c) 2006 by netfxfactory.org
// **********************************************************************
//
//  2006 by netfxfactory.org. All rights reserved.
//
// This copy is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// pascal.recchia@netfxfactory.org
// anthony.guerot@netfxfactory.org
// **********************************************************************
#endregion

using System;
using System.Text;
using System.CodeDom;
using System.Xml.Schema;
using System.Web.Services;
using System.CodeDom.Compiler;
using System.Xml.Serialization;
using System.Collections.Generic;
using System.Xml.Serialization.Advanced;

namespace thinktecture.ProxyModel.Web.Services
{
  public sealed class SchemaImporterExtension<TProxy> : SchemaImporterExtension
  {
    #region fields

    private XmlQualifiedNameTypeCollection _xmlQualifiedNameTypeCollection = null;

    #endregion
    #region ctors

    public SchemaImporterExtension()
    {
      if (!typeof(TProxy).IsInterface)
      {
        throw new ArgumentException("interfaceType must be an intetface", "interfaceType");
      }
      _xmlQualifiedNameTypeCollection = new XmlQualifiedNameTypeCollection();
      this.Initialize();
    }

    #endregion
    #region methods

    private void Initialize()
    {
      string __namespace = null;
      object[] __webServiceAttributes = typeof(TProxy).GetCustomAttributes(typeof(WebServiceAttribute), false);
      if (__webServiceAttributes.Length == 1)
      {
        __namespace = ((WebServiceAttribute)__webServiceAttributes[0]).Namespace;
      }

      TypeExporter __typeExporter = new TypeExporter(typeof(TProxy));
      Type[] __types = __typeExporter.Export();
      foreach (Type type in __types)
      {
        if (string.IsNullOrEmpty(__namespace))
        {
          _xmlQualifiedNameTypeCollection.Add(type);
        }
        else
        {
          _xmlQualifiedNameTypeCollection.Add(__namespace, type);
        }
      }

    }
    public override string ImportSchemaType(string name, string ns, XmlSchemaObject context, XmlSchemas schemas, XmlSchemaImporter importer, CodeCompileUnit compileUnit, CodeNamespace mainNamespace, CodeGenerationOptions options, CodeDomProvider codeProvider)
    {
      Type _type = null;
      string __key = XmlQualifiedNameTypeCollection.GetKey(ns, name);
      if (_xmlQualifiedNameTypeCollection.Contains(__key))
      {
        _type = _xmlQualifiedNameTypeCollection[__key];
      }
      else if (_xmlQualifiedNameTypeCollection.Contains(name))
      {
        _type = _xmlQualifiedNameTypeCollection[name];
      }
      if (_type == null)
      {
        return null;
      }
      compileUnit.ReferencedAssemblies.Add(_type.Assembly.Location);
      return _type.FullName;
    }

    #endregion
  }
}
