#region (c) 2002-2006 by thinktecture
// **********************************************************************
//
//  2002-2006 by thinktecture, Ingo Rammer and Christian Weyer. All rights reserved.
//
// This copy of thinktecture is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// Christian Weyer (christian.weyer@thinktecture.com)
//
// **********************************************************************
#endregion
#region (c) 2006 by netfxfactory.org
// **********************************************************************
//
//  2006 by netfxfactory.org. All rights reserved.
//
// This copy is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// pascal.recchia@netfxfactory.org
// anthony.guerot@netfxfactory.org
// **********************************************************************
#endregion

using System;
using System.Collections.Generic;
using System.Text;

namespace thinktecture.ProxyModel.Web.Services
{
  /// <summary>
  /// The exception that is thrown when an attempt to clear temporary local proxy assembly cache fails.
  /// </summary>
  [Serializable]
  public class TemporaryCacheException : Exception
  {
    #region ctors

    /// <summary>
    /// Initializes a new instance of the <see cref="TemporaryCacheException"/> class with a specified error message. 
    /// </summary>
    /// <param name="message">The error message that explains the reason for the exception.</param>
    public TemporaryCacheException(string message)
      : base(message)
    {
    }
    /// <summary>
    /// Initializes a new instance of the <see cref="TemporaryCacheException"/> class with a specified error message and a reference to the inner exception that is the cause of this exception. 
    /// </summary>
    /// <param name="message">The error message that explains the reason for the exception.</param>
    /// <param name="inner">The exception that is the cause of the current exception, or a null reference (Nothing in Visual Basic) if no inner exception is specified.</param>
    public TemporaryCacheException(string message, Exception inner)
      : base(message, inner)
    {
    }

    #endregion
  }
}
