#region (c) 2002-2006 by thinktecture
// **********************************************************************
//
//  2002-2006 by thinktecture, Ingo Rammer and Christian Weyer. All rights reserved.
//
// This copy of thinktecture is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// Christian Weyer (christian.weyer@thinktecture.com)
//
// **********************************************************************
#endregion
#region (c) 2006 by netfxfactory.org
// **********************************************************************
//
//  2006 by netfxfactory.org. All rights reserved.
//
// This copy is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// pascal.recchia@netfxfactory.org
// anthony.guerot@netfxfactory.org
// **********************************************************************
#endregion

using System;
using System.Collections.Generic;
using System.Text;

namespace thinktecture.ProxyModel.Web.Services
{
  /// <summary>
  /// Represents a set of options used by the <see cref="WebServiceProxyBuilder"/> class. 
  /// </summary>
  internal struct WebServiceProxyBuilderOptions
  {
    #region fields

    private CachePolicy _cachePolicy;
    private WebServiceTechnologies _webServiceTechnologies;
    private string _protocolName;

    #endregion
    #region ctors

    public WebServiceProxyBuilderOptions(CachePolicy cachePolicy):this(cachePolicy, WebServiceTechnologies.Asmx, ProtocolNames.SOAP)
    {
    }
    public WebServiceProxyBuilderOptions(CachePolicy cachePolicy, WebServiceTechnologies webServiceTechnologies, string protocolName)
    {
      _cachePolicy = cachePolicy;
      _webServiceTechnologies = webServiceTechnologies;
      _protocolName = protocolName;
    }

    #endregion
    #region props

    /// <summary>
    /// Gets or sets the cache policy.
    /// </summary>
    public CachePolicy CachePolicy
    {
      get { return _cachePolicy; }
      set { _cachePolicy = value; }
    }
    /// <summary>
    /// Get or sets the web service technologies
    /// </summary>
    public WebServiceTechnologies WebServiceTechnologies
    {
      get { return _webServiceTechnologies; }
      set { _webServiceTechnologies = value; }
    }
    /// <summary>
    ///Gets or sets the protocol associated with the wsdl document.
    /// </summary>
    /// <remarks>
    /// Allowed protocol strings include "Soap" (indicating SOAP 1.0) and "Soap12" (indicating SOAP 1.2).
    /// For more information on SOAP, see the World Wide Web Consortium Web site, at www.w3.org.
    /// </remarks>
    public string ProtocolName
    {
      get { return _protocolName; }
      set { _protocolName = value; }
    }

    #endregion
  }
}
