#region (c) 2002-2006 by thinktecture
// **********************************************************************
//
//  2002-2006 by thinktecture, Ingo Rammer and Christian Weyer. All rights reserved.
//
// This copy of thinktecture is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// Christian Weyer (christian.weyer@thinktecture.com)
//
// **********************************************************************
#endregion
#region (c) 2006 by netfxfactory.org
// **********************************************************************
//
//  2006 by netfxfactory.org. All rights reserved.
//
// This copy is licensed to you under the terms described in the
// License.txt file included in this distribution.
//
// Author: 
// pascal.recchia@netfxfactory.org
// anthony.guerot@netfxfactory.org
// **********************************************************************
#endregion

using System;
using System.Text;
using System.Xml.Serialization;
using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace thinktecture.ProxyModel.Web.Services
{
  internal sealed class XmlQualifiedNameTypeCollection : KeyedCollection<string, Type>
  {
    #region methods

    internal void Add(string ns, Type item)
    {
      string __namespace = null;
      object[] __xmlRootAttributes = item.GetCustomAttributes(typeof(XmlRootAttribute), false);
      if (__xmlRootAttributes.Length == 1)
      {
        __namespace = ((XmlRootAttribute)__xmlRootAttributes[0]).Namespace;
      }
      if (string.IsNullOrEmpty(__namespace))
      {
        __namespace = ns;
      }
      this.Add(item);
      this.ChangeItemKey(item, XmlQualifiedNameTypeCollection.GetKey(__namespace, item.Name));
    }
    protected override string GetKeyForItem(Type item)
    {
      string __namespace = null;
      object[] __xmlRootAttributes = item.GetCustomAttributes(typeof(XmlRootAttribute), false);
      if (__xmlRootAttributes.Length == 1)
      {
        __namespace = ((XmlRootAttribute)__xmlRootAttributes[0]).Namespace;
      }
      return XmlQualifiedNameTypeCollection.GetKey(__namespace, item.Name);
    }
    internal static string GetKey(string ns, string name)
    {
      return (string.IsNullOrEmpty(ns) ? name : string.Format("{0}:{1}", ns, name));
    }

    #endregion
  }
}
