using System;
using System.Collections.Generic;
using System.Text;

using thinktecture.ProxyModel;
using Contracts1;

namespace WSClient
{
  // TODO : Test if the wsdl doesn't exist.
  class Program
  {
    #region consts

    private const string ROOT = "http://localhost:3186/WebService/";

    #endregion
    #region methods

    static string GetWsdlLocation(string asmxServiceName)
    {
      return string.Format("{0}{1}.asmx?wsdl", ROOT,asmxServiceName);
    }
    static void CallService()
    {
      string __wsdlLocation = GetWsdlLocation("Service");
      ProxyFactory<IServiceSoap> __proxyFactory = new ProxyFactory<IServiceSoap>(new Uri(__wsdlLocation));
      IServiceSoap __proxy = __proxyFactory.CreateProxy();
      string __helloWorld = __proxy.HelloWorld();
    }
    static void CallDataTypes()
    {
      string __wsdlLocation = GetWsdlLocation("DataTypes");
      ProxyFactory<IDataTypesSoap> __proxyFactory = new ProxyFactory<IDataTypesSoap>(new Uri(__wsdlLocation));
      IDataTypesSoap __proxy = __proxyFactory.CreateProxy();
      Order[] __orders = __proxy.GetOrders();
    }
    static void CallSoapHeaders()
    {
      string __wsdlLocation = GetWsdlLocation("SoapHeaders");
      ProxyFactory<IHeaderServiceSoap> __proxyFactory = new ProxyFactory<IHeaderServiceSoap>(new Uri(__wsdlLocation));
      IHeaderServiceSoap __proxy = __proxyFactory.CreateProxy();
      string __secureMethod1 = __proxy.SecureMethod();

      // On the client, create a new instance of the AuthHeader class
      AuthHeader __myHeader = new AuthHeader();

      //WARNING: This sample is for demonstration purposes only.  Username/password information is sent in plain text,
      //which should never be done in a real application. It is not secure without modification.  
      __myHeader.Username = "JaneDoe";
      __myHeader.Password = "password";

      // Set the AuthHeader public member of the Web service instance to myHeader
      __proxy.AuthHeaderValue = __myHeader;

      string __secureMethod2 = __proxy.SecureMethod();
    }
    static void CallTypeSharingService1()
    {
      string __wsdlLocation = GetWsdlLocation("TypeSharingService1");
      ProxyFactory<INoAddedMethodsToITypeSharingService1> __proxyFactory = new ProxyFactory<INoAddedMethodsToITypeSharingService1>(new Uri(__wsdlLocation));
      INoAddedMethodsToITypeSharingService1 __proxy = __proxyFactory.CreateProxy();
      ProductInvoice __productInvoice = __proxy.createOrder("Product1", 10);
    }
    static void CallReturnVoid()
    {
      string __wsdlLocation = GetWsdlLocation("ReturnVoid");
      ProxyFactory<IReturnVoid> __proxyFactory = new ProxyFactory<IReturnVoid>(new Uri(__wsdlLocation));
      IReturnVoid __proxy = __proxyFactory.CreateProxy();
      __proxy.Do("message", DateTime.Now);
    }
    static void CallComplexTypesDistributedOnMultipleLibraries()
    {
      string __wsdlLocation = GetWsdlLocation("ComplexTypesDistributedOnMultipleLibraries");
      ProxyFactory<IComplexTypesDistributedOnMultipleLibraries> __proxyFactory = new ProxyFactory<IComplexTypesDistributedOnMultipleLibraries>(new Uri(__wsdlLocation));
      IComplexTypesDistributedOnMultipleLibraries __proxy = __proxyFactory.CreateProxy();
      Contact __contact = __proxy.GetContact("Pascal", "RECCHIA");
    }
    static void CallComplexTypesDistributedOnMultipleLibraries2()
    {
      string __wsdlLocation = GetWsdlLocation("ComplexTypesDistributedOnMultipleLibraries");
      ProxyFactory<IComplexTypesDistributedOnMultipleLibraries> __proxyFactory = new ProxyFactory<IComplexTypesDistributedOnMultipleLibraries>(new Uri(__wsdlLocation));
      IComplexTypesDistributedOnMultipleLibraries __proxy = __proxyFactory.CreateProxy();
      Contracts2.Person __person = new Contracts2.Person("Pascal", "RECCHIA");
      Contracts2.Contact __contact = __proxy.GetContact2(__person);
    }
    static void Main(string[] args)
    {
      Console.WriteLine("CallService");
      CallService();
      Console.WriteLine("CallDataTypes");
      CallDataTypes();
      //Console.WriteLine("CallDataTypes2");
      //CallDataTypes2();
      //CallDataTypes2();
      Console.WriteLine("CallSoapHeaders");
      CallSoapHeaders();
      Console.WriteLine("CallTypeSharingService1");
      CallTypeSharingService1();
      Console.WriteLine("CallReturnVoid");
      CallReturnVoid();
      Console.WriteLine("CallComplexTypesDistributedOnMultipleLibraries");
      CallComplexTypesDistributedOnMultipleLibraries();
      Console.WriteLine("CallComplexTypesDistributedOnMultipleLibraries2");
      CallComplexTypesDistributedOnMultipleLibraries2();

      Console.WriteLine("Press any key to exit!");
      Console.ReadLine();
    }

    #endregion   
  }
}
