using System;
using System.Collections.Generic;
using System.Text;
using thinktecture.ProxyModel;
using thinktecture.ProxyModel.Test;

namespace Client
{
  class Program
  {
    static void TestIt(ProxyFactory<IStockService> proxyFactory)
    {
      IStockService __proxy = proxyFactory.CreateProxy();

      // Call the service
      //Console.WriteLine("Calling {0}", WSDL);
      String[] symbols = { "FABRIKAM", "CONTOSO" };
      StockQuote[] quotes = __proxy.GetStockQuotes(symbols);

      // Success!
      Console.WriteLine("Remoting Service called successfully. Simple view:");
      foreach (StockQuote quote in quotes)
      {
        Console.WriteLine("");
        Console.WriteLine("Symbol: " + quote.Symbol);
        Console.WriteLine("\tName:\t\t\t" + quote.Name);
        Console.WriteLine("\tLast Price:\t\t" + quote.Last);
        Console.WriteLine("\tPrevious Change:\t" + quote.PreviousChange + "%");
      }
    }
    static void Main(string[] args)
    {
      Console.WriteLine("TestIt(new ProxyFactory<IStockService>());");

      // Take the first endpoint element defined for this contract in the configuration file.
      //TestIt(new ProxyFactory<IStockService>());

      Console.WriteLine("TestIt(new ProxyFactory<IStockService>(\"StockService\"));");

      // Take the endpoint element named "RemotingStockService" defined for this contract in the configuration file.
      TestIt(new ProxyFactory<IStockService>("StockService"));
      //TestIt(new ProxyFactory<IStockService>(CommunicationTechnology.Remoting, new Uri("http://localhost:51640/WebService/StockService.asmx?WSDL")));

      Console.WriteLine("Press any key to exit!");
      Console.ReadLine();
    }
  }
}
