using System;
using System.Web;
using System.Web.Services;
using System.Xml.Serialization;
using System.Collections.Generic;
using System.Web.Services.Protocols;

using thinktecture.ProxyModel.Test;

[WebService(Namespace = "http://stockservice.contoso.com/wse/samples/2005/10")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class StockService : System.Web.Services.WebService
{
  #region ctors

  public StockService()
  {
  }

  #endregion
  #region methods

  [WebMethod]
  [SoapDocumentMethod(ResponseElementName = "StockQuotes")]
  [return: XmlElement("StockQuote")]
  public List<StockQuote> GetStockQuotes([XmlArray(IsNullable = true), XmlArrayItem("Symbol", IsNullable = false)] string[] symbols)
  {
    List<StockQuote> quotes = new List<StockQuote>();

    foreach (String symbol in symbols)
    {
      StockQuote quote = new StockQuote();
      quote.Symbol = symbol;
      if (symbol == "FABRIKAM")
      {
        quote.Name = "Fabrikam, Inc.";
        quote.Last = 120.00;
        quote.PreviousChange = 5.5;
      }
      else
      {
        quote.Name = "Contoso Corp.";
        quote.Last = 50.07;
        quote.PreviousChange = 1.15;
      }
      quotes.Add(quote);
    }
    return quotes;
  }
  
  #endregion
}
