using System;
using System.Collections.Generic;
using System.Text;
using thinktecture.ProxyModel;
using thinktecture.ProxyModel.Test.Wse;
using Microsoft.Web.Services3.QuickStart;

namespace StockServiceClient
{
  class Program
  {
    private const string WSDL = "http://localhost:1752/StockService/StockService.asmx?WSDL";
    static void Main(string[] args)
    {
      ProxyFactory<IStockService> __proxyFactory = new ProxyFactory<IStockService>(new Uri(WSDL));
      IStockService __proxy = __proxyFactory.CreateProxy();

      // Call the service
      Console.WriteLine("Calling {0}", WSDL);
      String[] symbols = { "FABRIKAM", "CONTOSO" };
      StockQuote[] quotes = __proxy.StockQuoteRequest(symbols);

      // Success!
      Console.WriteLine("Web Service called successfully. Simple view:");
      foreach (StockQuote quote in quotes)
      {
        Console.WriteLine("");
        Console.WriteLine("Symbol: " + quote.Symbol);
        Console.WriteLine("\tName:\t\t\t" + quote.Name);
        Console.WriteLine("\tLast Price:\t\t" + quote.Last);
        Console.WriteLine("\tPrevious Change:\t" + quote.PreviousChange + "%");
      }
    }
  }
}
