using System;
using System.Xml.Serialization;

namespace StockServiceLibrary
{
    //
    // This class is an XML Serializable class for a StockQuote complexType.
    // It produces the following XML element:
    //
    //  <StockQuote xmlns="http://stockservice.contoso.com/wse/samples">
    //      <Symbol>string</Symbol>
    //      <Last>double</Last>
    //      <Date>dateTime</Date>
    //      <Change>double</Change>
    //      <Open>double</Open>
    //      <High>double</High>
    //      <Low>double</Low>
    //   </StockQuote>    
    //
    [XmlRoot(Namespace = "http://stockservice.contoso.com/wse/samples")]
    public class StockQuote
    {
        public String Symbol;
        public double Last;
        public DateTime Date;
        public double Change;
        public double Open;
        public double High;
        public double Low;
    }
}